diff --git a/tests/test_workflow_import.py b/tests/test_workflow_import.py
index d36db5e7..67ca3a07 100644
--- a/tests/test_workflow_import.py
+++ b/tests/test_workflow_import.py
@@ -33,7 +33,6 @@ from wcs.wf.form import FormWorkflowStatusItem, WorkflowFormFieldsFormDef
 from wcs.wf.jump import JumpWorkflowStatusItem
 from wcs.fields import StringField, FileField
 from wcs.qommon.form import UploadedFile
-from wcs.roles import Role
 from wcs.workflows import ExportToModel, WorkflowVariablesFieldsFormDef, DisplayMessageWorkflowStatusItem
 
 
@@ -117,7 +116,7 @@ def test_action_dispatch(pub):
     wf = Workflow(name='status')
     st1 = wf.add_status('Status1', 'st1')
 
-    role = Role()
+    role = pub.role_class()
     role.id = '5'
     role.name = 'Test Role'
     role.store()
@@ -174,7 +173,7 @@ def test_status_actions_named_role(pub):
 
 
 def test_status_actions_named_existing_role(pub):
-    role = Role()
+    role = pub.role_class()
     role.id = '2'
     role.name = 'Test Role named existing role'
     role.store()
@@ -206,12 +205,12 @@ def test_status_actions_named_existing_role(pub):
 
 
 def test_status_actions_named_missing_role(pub):
-    role = Role()
+    role = pub.role_class()
     role.id = '3'
     role.name = 'Test Role A'
     role.store()
 
-    role = Role()
+    role = pub.role_class()
     role.id = '4'
     role.name = 'Test Role B'
     role.store()
@@ -241,19 +240,19 @@ def test_status_actions_named_missing_role(pub):
     xml_export = xml_export_orig.replace(
         b'<item role_id="3">Test Role A</item>', b'<item role_id="999">foobar</item>'
     )
-    nb_roles = Role.count()
+    nb_roles = pub.role_class.count()
     wf3 = Workflow.import_from_xml_tree(ET.parse(io.BytesIO(xml_export)))
-    assert Role.count() == nb_roles + 1
+    assert pub.role_class.count() == nb_roles + 1
 
     # check that it doesn't fallback on the id if there's no match on the
     # name
-    nb_roles = Role.count()
+    nb_roles = pub.role_class.count()
     xml_export = xml_export_orig.replace(
         b'<item role_id="3">Test Role A</item>', b'<item role_id="3">Test Role C</item>'
     )
     wf3 = Workflow.import_from_xml_tree(ET.parse(io.BytesIO(xml_export)))
     assert wf3.possible_status[0].items[0].by != ['3']
-    assert Role.count() == nb_roles + 1
+    assert pub.role_class.count() == nb_roles + 1
 
     # on the other hand, check that it uses the id when included_id is True
     wf3 = Workflow.import_from_xml_tree(ET.parse(io.BytesIO(xml_export)), include_id=True)
@@ -455,7 +454,7 @@ def test_backoffice_info_text(pub):
 
 
 def test_global_actions(pub):
-    role = Role()
+    role = pub.role_class()
     role.id = '5'
     role.name = 'Test Role'
     role.store()
@@ -481,7 +480,7 @@ def test_global_actions(pub):
 
 
 def test_register_comment_to(pub):
-    role = Role()
+    role = pub.role_class()
     role.id = '5'
     role.name = 'Test Role'
     role.store()
@@ -526,13 +525,13 @@ def test_complex_dispatch_action(pub):
     wf = Workflow(name='status')
     st1 = wf.add_status('Status1', 'st1')
 
-    Role.wipe()
+    pub.role_class.wipe()
 
-    role1 = Role()
+    role1 = pub.role_class()
     role1.name = 'Test Role 1'
     role1.store()
 
-    role2 = Role()
+    role2 = pub.role_class()
     role2.name = 'Test Role 2'
     role2.store()
 
@@ -550,13 +549,13 @@ def test_complex_dispatch_action(pub):
     assert wf2.possible_status[0].items[0].rules == dispatch.rules
     assert wf2.possible_status[0].items[0].dispatch_type == 'automatic'
 
-    Role.wipe()
+    pub.role_class.wipe()
 
-    role3 = Role()
+    role3 = pub.role_class()
     role3.name = 'Test Role 1'
     role3.store()
 
-    role4 = Role()
+    role4 = pub.role_class()
     role4.name = 'Test Role 2'
     role4.store()
 
@@ -605,9 +604,9 @@ def test_sendmail_other_destination(pub):
     st1.items.append(sendmail)
     sendmail.parent = st1
 
-    Role.wipe()
+    pub.role_class.wipe()
     wf2 = assert_import_export_works(wf)
-    assert Role.count() == 0
+    assert pub.role_class.count() == 0
 
     sendmail.to = [
         '_submitter',
@@ -617,7 +616,7 @@ def test_sendmail_other_destination(pub):
         'foobar@localhost',
     ]
     wf2 = assert_import_export_works(wf)
-    assert Role.count() == 0
+    assert pub.role_class.count() == 0
     assert wf2.possible_status[0].items[0].to == sendmail.to
 
 
@@ -648,9 +647,9 @@ def test_sms(pub):
     st1.items.append(sendsms)
     sendsms.parent = st1
 
-    Role.wipe()
+    pub.role_class.wipe()
     wf2 = assert_import_export_works(wf)
-    assert Role.count() == 0
+    assert pub.role_class.count() == 0
     assert wf2.possible_status[0].items[0].to == sendsms.to
 
 
diff --git a/tests/test_workflows.py b/tests/test_workflows.py
index bc47c988..a7c4b0f0 100644
--- a/tests/test_workflows.py
+++ b/tests/test_workflows.py
@@ -47,7 +47,6 @@ from wcs.fields import (
     BlockField,
 )
 from wcs.formdata import Evolution
-from wcs.roles import Role
 from wcs.workflows import (
     Workflow,
     WorkflowStatusItem,
@@ -426,7 +425,7 @@ def test_check_auth(pub):
     user = pub.user_class(name='foo')
     user.store()
 
-    role = Role(name='bar1')
+    role = pub.role_class(name='bar1')
     role.store()
 
     formdef = FormDef()
@@ -475,8 +474,8 @@ def test_dispatch(pub):
     formdef.name = 'baz'
     formdef.store()
 
-    Role.wipe()
-    role = Role(name='xxx')
+    pub.role_class.wipe()
+    role = pub.role_class(name='xxx')
     role.store()
 
     item = DispatchWorkflowStatusItem()
@@ -516,10 +515,10 @@ def test_dispatch_auto(two_pubs):
     item.perform(formdata)
     assert not formdata.workflow_roles
 
-    Role.wipe()
-    role1 = Role('xxx1')
+    two_pubs.role_class.wipe()
+    role1 = two_pubs.role_class('xxx1')
     role1.store()
-    role2 = Role('xxx2')
+    role2 = two_pubs.role_class('xxx2')
     role2.store()
 
     for variable in ('form_var_foo', '{{form_var_foo}}'):
@@ -588,8 +587,8 @@ def test_dispatch_computed(two_pubs):
     formdef.name = 'baz'
     formdef.store()
 
-    Role.wipe()
-    role = Role(name='xxx')
+    two_pubs.role_class.wipe()
+    role = two_pubs.role_class(name='xxx')
     role.slug = 'yyy'
     role.store()
 
@@ -679,9 +678,9 @@ def test_add_remove_computed_roles(pub):
     formdata = formdef.data_class()()
     formdata.user_id = user.id
 
-    role = Role(name='plop')
+    role = pub.role_class(name='plop')
     role.store()
-    role2 = Role(name='xxx')
+    role2 = pub.role_class(name='xxx')
     role2.store()
 
     item = AddRoleWorkflowStatusItem()
@@ -723,7 +722,7 @@ def test_roles_idp(pub):
     user.name_identifiers = ['xxx']
     user.store()
 
-    role = Role(name='bar1')
+    role = pub.role_class(name='bar1')
     role.store()
 
     formdef = FormDef()
@@ -1156,9 +1155,9 @@ def test_register_comment_to(pub):
     workflow = Workflow(name='register comment to')
     st1 = workflow.add_status('Status1', 'st1')
 
-    role = Role(name='foorole')
+    role = pub.role_class(name='foorole')
     role.store()
-    role2 = Role(name='no-one-role')
+    role2 = pub.role_class(name='no-one-role')
     role2.store()
     user = pub.user_class(name='baruser')
     user.roles = []
@@ -1262,12 +1261,12 @@ def test_email(pub, emails):
     user.email = 'zorg@localhost'
     user.store()
 
-    Role.wipe()
-    role1 = Role(name='foo')
+    pub.role_class.wipe()
+    role1 = pub.role_class(name='foo')
     role1.emails = ['foo@localhost']
     role1.store()
 
-    role2 = Role(name='bar')
+    role2 = pub.role_class(name='bar')
     role2.emails = ['bar@localhost', 'baz@localhost']
     role2.store()
 
@@ -2790,7 +2789,7 @@ def test_display_form(two_pubs):
 
 
 def test_display_form_and_comment(pub):
-    role = Role(name='bar1')
+    role = pub.role_class(name='bar1')
     role.store()
 
     user = pub.user_class()
@@ -2854,7 +2853,7 @@ def test_display_form_migration(pub):
 
 
 def test_choice_button_no_label(pub):
-    role = Role(name='bar1')
+    role = pub.role_class(name='bar1')
     role.store()
 
     user = pub.user_class()
@@ -2957,9 +2956,9 @@ def test_workflow_display_message_to(pub):
     workflow = Workflow(name='display message to')
     st1 = workflow.add_status('Status1', 'st1')
 
-    role = Role(name='foorole')
+    role = pub.role_class(name='foorole')
     role.store()
-    role2 = Role(name='no-one-role')
+    role2 = pub.role_class(name='no-one-role')
     role2.store()
     user = pub.user_class(name='baruser')
     user.roles = []
@@ -3049,7 +3048,7 @@ def test_workflow_display_message_line_details(pub):
     display_message.position = 'actions'
     assert display_message.get_line_details() == 'with actions'
 
-    role = Role(name='foorole')
+    role = pub.role_class(name='foorole')
     role.store()
     display_message.to = [role.id]
     assert display_message.get_line_details() == 'with actions, for foorole'
@@ -3062,13 +3061,13 @@ def test_workflow_roles(pub, emails):
     user.email = 'zorg@localhost'
     user.store()
 
-    Role.wipe()
-    role1 = Role(name='foo')
+    pub.role_class.wipe()
+    role1 = pub.role_class(name='foo')
     role1.emails = ['foo@localhost']
     role1.details = 'Hello World'
     role1.store()
 
-    role2 = Role(name='bar')
+    role2 = pub.role_class(name='bar')
     role2.emails = ['bar@localhost', 'baz@localhost']
     role2.store()
 
@@ -5302,7 +5301,7 @@ def test_workflow_action_condition(two_pubs):
     st1 = workflow.add_status('Status1', 'st1')
     workflow.store()
 
-    role = Role(name='bar1')
+    role = two_pubs.role_class(name='bar1')
     role.store()
 
     user = two_pubs.user_class()
@@ -5424,7 +5423,7 @@ def test_notifications(pub, http_requests):
     # roles (not exposed in current UI)
     http_requests.empty()
 
-    role = Role(name='blah')
+    role = pub.role_class(name='blah')
     role.store()
 
     user1 = pub.user_class()
@@ -5484,10 +5483,10 @@ def test_workflow_field_migration(pub):
 
 def test_aggregation_email(pub, emails):
     Workflow.wipe()
-    Role.wipe()
+    pub.role_class.wipe()
     AggregationEmail.wipe()
 
-    role = Role(name='foobar')
+    role = pub.role_class(name='foobar')
     role.emails = ['foobar@localhost']
     role.emails_to_members = False
     role.store()
diff --git a/tests/utilities.py b/tests/utilities.py
index effda0cd..7b25b371 100644
--- a/tests/utilities.py
+++ b/tests/utilities.py
@@ -20,6 +20,7 @@ from wcs.qommon import force_str
 import wcs
 import wcs.wsgi
 from wcs import compat
+from wcs.roles import Role
 from wcs.users import User
 from wcs.tracking_code import TrackingCode
 import wcs.qommon.emails
@@ -77,6 +78,7 @@ def create_temporary_pub(sql_mode=False, templates_mode=False, lazy_mode=False):
 
     if sql_mode:
         pub.user_class = sql.SqlUser
+        pub.role_class = sql.Role
         pub.tracking_code_class = sql.TrackingCode
         pub.session_class = sql.Session
         pub.custom_view_class = sql.CustomView
@@ -85,6 +87,7 @@ def create_temporary_pub(sql_mode=False, templates_mode=False, lazy_mode=False):
         pub.is_using_postgresql = lambda: True
     else:
         pub.user_class = User
+        pub.role_class = Role
         pub.tracking_code_class = TrackingCode
         pub.session_class = sessions.BasicSession
         pub.custom_view_class = custom_views.CustomView
@@ -167,6 +170,7 @@ def create_temporary_pub(sql_mode=False, templates_mode=False, lazy_mode=False):
         pub.write_cfg()
 
         sql.do_user_table()
+        sql.do_role_table()
         sql.do_tracking_code_table()
         sql.do_session_table()
         sql.do_custom_views_table()
diff --git a/wcs/admin/forms.py b/wcs/admin/forms.py
index 99733669..4a0912a9 100644
--- a/wcs/admin/forms.py
+++ b/wcs/admin/forms.py
@@ -41,7 +41,7 @@ from wcs.qommon.afterjobs import AfterJob
 from wcs.formdef import FormDef, FormdefImportError, FormdefImportRecoverableError, DRAFTS_DEFAULT_LIFESPAN
 from wcs.carddef import CardDef
 from wcs.categories import Category
-from wcs.roles import Role, logged_users_role, get_user_roles
+from wcs.roles import logged_users_role, get_user_roles
 from wcs.workflows import Workflow
 from wcs.forms.root import qrcode
 
@@ -694,7 +694,7 @@ class FormDefPage(Directory):
                 role_id = self.formdef.workflow_roles.get(wf_role_id)
                 if role_id:
                     try:
-                        role = Role.get(role_id)
+                        role = get_publisher().role_class.get(role_id)
                         role_label = role.name
                     except KeyError:
                         # removed role ?
@@ -820,7 +820,7 @@ class FormDefPage(Directory):
                     roles.append(logged_users_role().name)
                 else:
                     try:
-                        roles.append(Role.get(x).name)
+                        roles.append(get_publisher().role_class.get(x).name)
                     except KeyError:
                         # removed role ?
                         roles.append(_('Unknown role (%s)') % x)
@@ -1784,7 +1784,7 @@ class FormsDirectory(AccessControlled, Directory):
 
     def form_actions(self):
         r = TemplateIO(html=True)
-        has_roles = bool(Role.count())
+        has_roles = bool(get_publisher().role_class.count())
         r += htmltext('<div id="appbar">')
         r += htmltext('<h2>%s</h2>') % _('Forms')
         if has_roles:
@@ -1825,7 +1825,7 @@ class FormsDirectory(AccessControlled, Directory):
 
     def new(self):
         get_response().breadcrumb.append(('new', _('New')))
-        if Role.count() == 0:
+        if get_publisher().role_class.count() == 0:
             return template.error_page('forms', _('You first have to define roles.'))
         formdefui = self.formdef_ui_class(None)
         form = formdefui.new_form_ui()
diff --git a/wcs/admin/roles.py b/wcs/admin/roles.py
index 0c05a65e..656c6658 100644
--- a/wcs/admin/roles.py
+++ b/wcs/admin/roles.py
@@ -24,7 +24,7 @@ from wcs.qommon.form import *
 
 from wcs.qommon.backoffice.menu import html_top
 
-from wcs.roles import Role, get_user_roles
+from wcs.roles import get_user_roles
 from wcs.formdef import FormDef
 
 
@@ -32,7 +32,7 @@ class RoleUI(object):
     def __init__(self, role):
         self.role = role
         if self.role is None:
-            self.role = Role()
+            self.role = get_publisher().role_class()
 
     def get_form(self):
         form = Form(enctype="multipart/form-data")
@@ -75,10 +75,10 @@ class RoleUI(object):
         if self.role:
             role = self.role
         else:
-            role = Role(name=form.get_widget('name').parse())
+            role = get_publisher().role_class(name=form.get_widget('name').parse())
 
         name = form.get_widget('name').parse()
-        role_names = [x.name for x in Role.select() if x.id != role.id]
+        role_names = [x.name for x in get_publisher().role_class.select() if x.id != role.id]
         if name in role_names:
             form.get_widget('name').set_error(_('This name is already used'))
             raise ValueError()
@@ -94,7 +94,7 @@ class RolePage(Directory):
 
     def __init__(self, component):
         try:
-            self.role = Role.get(component)
+            self.role = get_publisher().role_class.get(component)
         except KeyError:
             raise errors.TraversalError()
         self.role_ui = RoleUI(self.role)
diff --git a/wcs/admin/settings.py b/wcs/admin/settings.py
index 3a53b11e..038332e4 100644
--- a/wcs/admin/settings.py
+++ b/wcs/admin/settings.py
@@ -58,7 +58,6 @@ from wcs.carddef import CardDef
 from wcs.data_sources import NamedDataSource
 from wcs.formdef import FormDef
 from wcs.workflows import Workflow, WorkflowImportError
-from wcs.roles import Role
 
 from wcs.backoffice.studio import StudioDirectory
 from .fields import FieldDefPage, FieldsDirectory
@@ -545,7 +544,7 @@ class SettingsDirectory(QommonSettingsDirectory):
             )
 
         if enabled('permissions'):
-            roles = list(Role.select())
+            roles = list(get_publisher().role_class.select())
             if roles:
                 r += htmltext('<dt><a href="admin-permissions">%s</a></dt> <dd>%s</dd>') % (
                     _('Admin Permissions'),
@@ -689,7 +688,7 @@ class SettingsDirectory(QommonSettingsDirectory):
 
         rows = []
         value = []
-        roles = [x for x in Role.select(order_by='name') if not x.is_internal()]
+        roles = [x for x in get_publisher().role_class.select(order_by='name') if not x.is_internal()]
         for role in roles:
             rows.append(role.name)
             value.append([role.allows_backoffice_access])
@@ -998,7 +997,6 @@ class SettingsDirectory(QommonSettingsDirectory):
                 z = zipfile.ZipFile(c, 'w')
                 for d in self.dirs:
                     if d not in (
-                        'roles',
                         'categories',
                         'carddef_categories',
                         'wscalls',
@@ -1055,6 +1053,14 @@ class SettingsDirectory(QommonSettingsDirectory):
                             os.path.join('blockdefs_xml', str(blockdef.id)),
                             b'<?xml version="1.0"?>\n' + ET.tostring(node),
                         )
+                if 'roles' in self.dirs:
+                    for role in get_publisher().role_class.select():
+                        node = role.export_to_xml(include_id=True)
+                        misc.indent_xml(node)
+                        z.writestr(
+                            os.path.join('roles_xml', str(role.id)),
+                            b'<?xml version="1.0"?>\n' + ET.tostring(node),
+                        )
 
                 if self.settings:
                     z.write(os.path.join(self.app_dir, 'config.pck'), 'config.pck')
diff --git a/wcs/admin/users.py b/wcs/admin/users.py
index a8a3d48a..7b0931a3 100644
--- a/wcs/admin/users.py
+++ b/wcs/admin/users.py
@@ -23,7 +23,6 @@ import wcs.qommon.storage as st
 from wcs.qommon import errors
 from wcs.qommon import misc, get_cfg
 from wcs.qommon.backoffice.listing import pagination_links
-from wcs.roles import Role
 
 from wcs.qommon import ident
 from wcs.qommon.ident.idp import is_idp_managing_user_attributes, is_idp_managing_user_roles
@@ -56,7 +55,7 @@ class UserUI(object):
                 formdef.add_fields_to_form(form, form_data=self.user.form_data)
             form.add(CheckboxWidget, 'is_admin', title=_('Administrator Account'), value=self.user.is_admin)
 
-        roles = list(Role.select(order_by='name'))
+        roles = list(get_publisher().role_class.select(order_by='name'))
         if len(roles) and not is_idp_managing_user_roles():
             form.add(
                 WidgetList,
@@ -187,7 +186,7 @@ class UserPage(Directory):
                 r += htmltext('<li><strong>%s</strong></li>') % _('Site Administrator')
             for k in self.user.roles or []:
                 try:
-                    r += htmltext('<li>%s</li>') % Role.get(k).name
+                    r += htmltext('<li>%s</li>') % get_publisher().role_class.get(k).name
                 except KeyError:
                     # removed role ?
                     r += htmltext('<li><em>')
@@ -332,7 +331,7 @@ class UsersDirectory(Directory):
             # optimize query by removing the roles criterias if they are all
             # checked
             possible_roles = ['admin', 'none']
-            possible_roles.extend(Role.keys())
+            possible_roles.extend(get_publisher().role_class.keys())
             if set(possible_roles) == set(checked_roles):
                 checked_roles = None
 
@@ -464,7 +463,7 @@ class UsersDirectory(Directory):
         r += htmltext('<input type="hidden" name="filter" value="true"/>')
         r += htmltext('<ul>')
         roles = [('admin', _('Site Administrator'))]
-        for role in Role.select():
+        for role in get_publisher().role_class.select():
             roles.append((role.id, role.name))
         roles.append(('none', _('None')))
 
diff --git a/wcs/api.py b/wcs/api.py
index 6e336c6f..cd5bff88 100644
--- a/wcs/api.py
+++ b/wcs/api.py
@@ -38,7 +38,7 @@ from wcs.conditions import Condition, ValidationError
 from wcs.carddef import CardDef
 from wcs.formdef import FormDef
 from wcs.data_sources import get_object as get_data_source_object
-from wcs.roles import Role, logged_users_role
+from wcs.roles import logged_users_role
 from wcs.forms.common import FormStatusPage
 import wcs.qommon.storage as st
 from wcs.api_utils import sign_url_auto_orig, is_url_signed, get_user_from_api_query_string, get_query_flag
@@ -695,7 +695,9 @@ class ApiFormdefsDirectory(Directory):
                 role_id = formdef_workflow_roles.get(wf_role_id)
                 if role_id:
                     try:
-                        workflow_function['role'] = Role.get(role_id).get_json_export_dict()
+                        workflow_function['role'] = (
+                            get_publisher().role_class.get(role_id).get_json_export_dict()
+                        )
                     except KeyError:
                         pass
                 formdict['functions'][wf_role_id] = workflow_function
@@ -814,7 +816,7 @@ class ApiUserDirectory(Directory):
         user_info = user.get_substitution_variables(prefix='')
         del user_info['user']
         user_info['id'] = user.id
-        user_roles = [Role.get(x, ignore_errors=True) for x in user.roles or []]
+        user_roles = [get_publisher().role_class.get(x, ignore_errors=True) for x in user.roles or []]
         user_info['user_roles'] = [x.get_json_export_dict() for x in user_roles if x]
         return json.dumps(user_info, cls=misc.JSONEncoder)
 
@@ -953,7 +955,7 @@ class ApiUsersDirectory(Directory):
             user_info = user.get_substitution_variables(prefix='')
             del user_info['user']
             user_info['user_id'] = user.id
-            user_roles = [Role.get(x, ignore_errors=True) for x in user.roles or []]
+            user_roles = [get_publisher().role_class.get(x, ignore_errors=True) for x in user.roles or []]
             user_info['user_roles'] = [x.get_json_export_dict() for x in user_roles if x]
             # add attributes to be usable as datasource
             user_info['id'] = user.id
@@ -1085,8 +1087,7 @@ class ApiDirectory(Directory):
         if not (is_url_signed() or (get_request().user and get_request().user.can_go_in_admin())):
             raise AccessForbiddenError('unsigned request or user has no access to backoffice')
         list_roles = []
-        charset = get_publisher().site_charset
-        for role in Role.select():
+        for role in get_publisher().role_class.select():
             if not role.is_internal():
                 list_roles.append(role.get_json_export_dict())
         get_response().set_content_type('application/json')
diff --git a/wcs/backoffice/cards.py b/wcs/backoffice/cards.py
index ee2364df..46f90c1b 100644
--- a/wcs/backoffice/cards.py
+++ b/wcs/backoffice/cards.py
@@ -26,7 +26,6 @@ from ..qommon.storage import NotEqual, Null
 
 from wcs.carddef import CardDef
 from wcs.categories import CardDefCategory
-from wcs.roles import Role
 from wcs.workflows import Workflow
 from wcs.admin.categories import CardDefCategoriesDirectory
 from wcs.admin.forms import FormsDirectory, FormDefPage, FormDefUI, html_top, OptionsDirectory
@@ -142,7 +141,7 @@ class CardDefPage(FormDefPage):
                 role_id = self.formdef.workflow_roles.get(wf_role_id)
                 if role_id:
                     try:
-                        role = Role.get(role_id)
+                        role = get_publisher().role_class.get(role_id)
                         role_label = role.name
                     except KeyError:
                         # removed role ?
diff --git a/wcs/backoffice/management.py b/wcs/backoffice/management.py
index e1cfd458..c3601b82 100644
--- a/wcs/backoffice/management.py
+++ b/wcs/backoffice/management.py
@@ -72,7 +72,7 @@ from wcs.admin.settings import UserFieldsFormDef
 from wcs.categories import Category
 from wcs.formdata import FormData
 from wcs.formdef import FormDef
-from wcs.roles import logged_users_role, Role
+from wcs.roles import logged_users_role
 from wcs.variables import LazyFieldVar
 from wcs.workflows import template_on_formdata, WorkflowStatusItem
 
@@ -3296,7 +3296,7 @@ class FormBackOfficeStatusPage(FormStatusPage):
                 acting_role_id = self.filled.get_role_translation(key)
                 if acting_role_id:
                     try:
-                        acting_role = Role.get(acting_role_id)
+                        acting_role = get_publisher().role_class.get(acting_role_id)
                         r += htmltext('<div class="value"><span>%s</span></div>') % acting_role.name
                     except KeyError:
                         r += htmltext('<div class="value"><span>%s %s</span></div>') % (
diff --git a/wcs/ctl/hobo_notify.py b/wcs/ctl/hobo_notify.py
index efc31031..d3b584dd 100644
--- a/wcs/ctl/hobo_notify.py
+++ b/wcs/ctl/hobo_notify.py
@@ -19,7 +19,6 @@ import sys
 import json
 
 from quixote import get_publisher
-from wcs.roles import Role
 from ..qommon.ctl import Command
 from ..qommon.publisher import get_cfg
 from wcs.admin.settings import UserFieldsFormDef
@@ -116,11 +115,11 @@ class CmdHoboNotify(Command):
                 emails = [force_str(email) for email in o['emails']]
                 emails_to_members = o['emails_to_members']
             # Find existing role
-            role = Role.resolve(uuid, slug, name)
+            role = get_publisher().role_class.resolve(uuid, slug, name)
             if not role:
                 if action != 'provision':
                     continue
-                role = Role(id=uuid)
+                role = get_publisher().role_class(id=uuid)
             if action == 'provision':
                 # Provision/rename
                 role.name = name
@@ -138,7 +137,7 @@ class CmdHoboNotify(Command):
                 role.remove_self()
         # All roles have been sent
         if full and action == 'provision':
-            for role in Role.select(ignore_errors=True):
+            for role in get_publisher().role_class.select(ignore_errors=True):
                 if role and role.uuid not in uuids:
                     role.remove_self()
 
@@ -186,7 +185,7 @@ class CmdHoboNotify(Command):
                     user.is_admin = o.get('is_superuser', False)
                     user.roles = []
                     for role_ref in o.get('roles', []):
-                        role = Role.resolve(role_ref['uuid'])
+                        role = get_publisher().role_class.resolve(role_ref['uuid'])
                         if role and role.id not in user.roles:
                             user.add_roles([role.id])
                     user.set_attributes_from_formdata(user.form_data)
@@ -203,7 +202,7 @@ class CmdHoboNotify(Command):
                     users = User.get_users_with_name_identifier(o['uuid'])
                     for user in users:
                         user.set_deleted()
-            except Exception as e:
+            except Exception:
                 publisher.notify_of_exception(sys.exc_info(), context='[PROVISIONNING]')
 
 
diff --git a/wcs/formdata.py b/wcs/formdata.py
index 0b37fd4c..3b83899f 100644
--- a/wcs/formdata.py
+++ b/wcs/formdata.py
@@ -33,7 +33,6 @@ from .qommon.publisher import get_cfg
 from .qommon.substitution import Substitutions, invalidate_substitution_cache
 from .qommon.template import Template
 
-from .roles import Role
 from .fields import FileField
 
 
@@ -694,7 +693,7 @@ class FormData(StorableObject):
 
     def get_handling_role(self):
         try:
-            return Role.get(self.get_handling_role_id())
+            return get_publisher().role_class.get(self.get_handling_role_id())
         except KeyError:
             return None
 
@@ -840,7 +839,7 @@ class FormData(StorableObject):
         for role_type, role_id in workflow_roles.items():
             prefix = 'form_role_%s_' % role_type.replace('-', '_').strip('_')
             try:
-                d.update(Role.get(role_id).get_substitution_variables(prefix))
+                d.update(get_publisher().role_class.get(role_id).get_substitution_variables(prefix))
             except KeyError:
                 pass
 
@@ -1202,7 +1201,7 @@ class FormData(StorableObject):
             # exclude special _submitter value
             role_list = [x for x in data['roles'][role_key] if x != '_submitter']
             # get role objects
-            role_list = [Role.get(x, ignore_errors=True) for x in role_list]
+            role_list = [get_publisher().role_class.get(x, ignore_errors=True) for x in role_list]
             # export as json dicts
             role_list = [x.get_json_export_dict() for x in role_list if x is not None]
             data['roles'][role_key] = role_list
diff --git a/wcs/formdef.py b/wcs/formdef.py
index e045b6b9..65e4b1ee 100644
--- a/wcs/formdef.py
+++ b/wcs/formdef.py
@@ -41,7 +41,7 @@ from .qommon.substitution import Substitutions
 from .qommon.publisher import get_publisher_class
 
 from .formdata import FormData
-from .roles import Role, logged_users_role
+from .roles import logged_users_role
 from .categories import Category
 from . import fields
 from . import data_sources
@@ -984,7 +984,7 @@ class FormDef(StorableObject):
                     role = force_text(role_id, charset)
                 else:
                     try:
-                        role = force_text(Role.get(role_id).name, charset)
+                        role = force_text(get_publisher().role_class.get(role_id).name, charset)
                     except KeyError:
                         role = force_text(role_id, charset)
                 sub = ET.SubElement(roles, 'role')
@@ -1002,7 +1002,7 @@ class FormDef(StorableObject):
                     role = force_text(role_id, charset)
                 else:
                     try:
-                        role = force_text(Role.get(role_id).name, charset)
+                        role = force_text(get_publisher().role_class.get(role_id).name, charset)
                     except KeyError:
                         role = force_text(role_id, charset)
                 sub = ET.SubElement(roles, 'role')
@@ -1196,11 +1196,11 @@ class FormDef(StorableObject):
                 role_id = value
             elif include_id:
                 role_id = role_node.attrib.get('role_id')
-                if role_id and not Role.has_key(role_id):
+                if role_id and not get_publisher().role_class.get(role_id, ignore_errors=True):
                     role_id = None
 
             if not role_id:
-                for role in Role.select(ignore_errors=True):
+                for role in get_publisher().role_class.select(ignore_errors=True):
                     if role.name == value:
                         role_id = role.id
                         break
